Index: /XIOS/trunk/src/fortran/ixios.F90
===================================================================
--- /XIOS/trunk/src/fortran/ixios.F90	(revision 312)
+++ /XIOS/trunk/src/fortran/ixios.F90	(revision 313)
@@ -4,8 +4,10 @@
 
 
-USE icontext, ONLY : txios(context), xios(set_context_attr), xios(set_context_attr_hdl),   &
-                     xios(get_context_handle), xios(set_current_context),                  &
+USE icontext, ONLY : txios(context), xios(get_context_handle), xios(set_current_context),    &
                      xios(is_valid_context)
 
+USE icontext_attr, ONLY : xios(set_context_attr), xios(set_context_attr_hdl), &
+                          xios(get_context_attr), xios(get_context_attr_hdl)
+                                               
 USE idata, ONLY : xios(initialize),xios(init_server), xios(finalize), xios(context_initialize),  &
                   xios(close_context_definition),       &
@@ -16,25 +18,50 @@
 USE idate, ONLY : txios(date),txios(time), xios(set_timestep),xios(update_calendar)
 
-USE idomain, ONLY : txios(domain), txios(domaingroup), xios(set_domaingroup_attr),       &
-                    xios(set_domaingroup_attr_hdl), xios(set_domain_attr), xios(set_domain_attr_hdl),&
-                    xios(get_domain_handle), xios(get_domaingroup_handle),xios(is_valid_domain),     &
+USE idomain, ONLY : txios(domain), txios(domaingroup), xios(get_domain_handle),  &
+                    xios(get_domaingroup_handle),xios(is_valid_domain),     &
                     xios(is_valid_domaingroup)
-                     
-USE ifield, ONLY : txios(field), txios(fieldgroup), xios(set_fieldgroup_attr),           &
-                   xios(set_fieldgroup_attr_hdl),xios(set_field_attr),xios(set_field_attr_hdl),      &
-                   xios(get_field_handle), xios(get_fieldgroup_handle), xios(is_valid_field),        &
+
+USE idomain_attr, ONLY :  xios(set_domain_attr), xios(set_domain_attr_hdl),  &
+                          xios(get_domain_attr), xios(get_domain_attr_hdl)
+
+USE idomaingroup_attr, ONLY : xios(set_domaingroup_attr), xios(set_domaingroup_attr_hdl),  & 
+                              xios(get_domaingroup_attr), xios(get_domaingroup_attr_hdl) 
+                    
+USE ifield, ONLY : txios(field), txios(fieldgroup), xios(get_field_handle),  &
+                   xios(get_fieldgroup_handle), xios(is_valid_field),        &
                    xios(is_valid_fieldgroup),xios(field_is_active_id),xios(field_is_active_hdl)  
-                   
-USE ifile, ONLY : txios(file), txios(filegroup), xios(set_file_attr),xios(set_file_attr_hdl), &
-                  xios(set_filegroup_attr), xios(set_filegroup_attr_hdl), xios(get_file_handle),    & 
+
+USE ifield_attr, ONLY : xios(set_field_attr),xios(set_field_attr_hdl),    &
+                        xios(get_field_attr),xios(get_field_attr_hdl)
+  
+USE ifieldgroup_attr, ONLY : xios(set_fieldgroup_attr), xios(set_fieldgroup_attr_hdl),  &
+                             xios(get_fieldgroup_attr), xios(get_fieldgroup_attr_hdl)
+
+USE ifile, ONLY : txios(file), txios(filegroup), xios(get_file_handle),    & 
                   xios(get_filegroup_handle), xios(is_valid_file), xios(is_valid_filegroup)
+
+USE ifile_attr, ONLY : xios(set_file_attr),xios(set_file_attr_hdl), &
+                       xios(get_file_attr),xios(get_file_attr_hdl)
+
+USE ifilegroup_attr, ONLY : xios(set_filegroup_attr), xios(set_filegroup_attr_hdl), &
+                            xios(get_filegroup_attr), xios(get_filegroup_attr_hdl)
                   
-USE igrid, ONLY : txios(grid), txios(gridgroup), xios(set_grid_attr), xios(set_grid_attr_hdl), &
-                  xios(set_gridgroup_attr), xios(set_gridgroup_attr_hdl), xios(get_grid_handle),     &
+USE igrid, ONLY : txios(grid), txios(gridgroup), xios(get_grid_handle),     &
                   xios(get_gridgroup_handle), xios(is_valid_grid), xios(is_valid_gridgroup) 
 
-USE iaxis, ONLY : txios(axis), txios(axisgroup), xios(set_axis_attr), xios(set_axis_attr_hdl), &
-                  xios(set_axisgroup_attr), xios(set_axisgroup_attr_hdl), xios(get_axis_handle),     &
+USE igrid_attr, ONLY : xios(set_grid_attr_hdl), xios(set_grid_attr), &
+                       xios(get_grid_attr_hdl), xios(get_grid_attr)
+
+USE igridgroup_attr, ONLY : xios(set_gridgroup_attr), xios(set_gridgroup_attr_hdl),  &
+                            xios(get_gridgroup_attr), xios(get_gridgroup_attr_hdl)
+
+USE iaxis, ONLY : txios(axis), txios(axisgroup), xios(get_axis_handle),     &
                   xios(get_axisgroup_handle), xios(is_valid_axis), xios(is_valid_axisgroup) 
+
+USE iaxis_attr, ONLY :  xios(set_axis_attr), xios(set_axis_attr_hdl), &
+                        xios(get_axis_attr), xios(get_axis_attr_hdl)
+
+USE iaxisgroup_attr, ONLY : xios(set_axisgroup_attr), xios(set_axisgroup_attr_hdl), &
+                            xios(get_axisgroup_attr), xios(get_axisgroup_attr_hdl)
 
 USE ixml_tree, ONLY : xios(add_axis), xios(add_file), xios(add_grid), xios(add_field), xios(add_domain),          &
@@ -52,4 +79,11 @@
                    xios(set_axisgroup_attr_hdl), xios(set_context_attr_hdl)
 END INTERFACE xios(set_attr)
+
+INTERFACE xios(get_attr)
+  MODULE PROCEDURE xios(get_domaingroup_attr_hdl), xios(get_domain_attr_hdl), xios(get_fieldgroup_attr_hdl), &
+                   xios(get_field_attr_hdl), xios(get_file_attr_hdl), xios(get_filegroup_attr_hdl),          &
+                   xios(get_grid_attr_hdl), xios(get_gridgroup_attr_hdl), xios(get_axis_attr_hdl) ,          &
+                   xios(get_axisgroup_attr_hdl), xios(get_context_attr_hdl)
+END INTERFACE xios(get_attr)
 
 INTERFACE xios(get_handle)
@@ -84,4 +118,9 @@
           xios(set_axisgroup_attr), xios(set_context_attr)
 
+ PUBLIC :: xios(get_attr), xios(get_domain_attr), xios(get_domaingroup_attr), xios(get_fieldgroup_attr), &
+          xios(get_field_attr), xios(get_file_attr), xios(get_filegroup_attr),          &
+          xios(get_grid_attr), xios(get_gridgroup_attr), xios(get_axis_attr) ,          &
+          xios(get_axisgroup_attr), xios(get_context_attr)
+
  PUBLIC :: xios(get_handle) 
  PUBLIC :: xios(add_child) 
Index: /XIOS/trunk/src/generate_fortran_interface.cpp
===================================================================
--- /XIOS/trunk/src/generate_fortran_interface.cpp	(revision 313)
+++ /XIOS/trunk/src/generate_fortran_interface.cpp	(revision 313)
@@ -0,0 +1,166 @@
+#include "xmlioserver.hpp"
+#include "generate_interface_impl.hpp"
+#include "indent.hpp"
+#include "attribute_template_impl.hpp"
+#include "object_template_impl.hpp"
+#include "group_template_impl.hpp"
+
+int main (int argc, char ** argv, char ** UNUSED (env))
+{
+//  string path="./src/attr_interface/" ;
+  string path="./interface/" ;
+  
+  CContext* context=tree::CTreeManager::CreateContext("interface").get();
+  CAxis axis ;
+  CAxisGroup axisgroup ;
+  CField field;
+  CFieldGroup fieldgroup ;
+  CDomain domain ;
+  CDomainGroup domaingroup ;
+  CGrid grid ;
+  CGridGroup gridgroup ;
+  
+  CFile afile;
+  CFileGroup filegroup;
+  
+  ostringstream oss ;
+  ofstream file;
+  
+  file.open((path+"axis_interface_attr.f90").c_str()); 
+  axis.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icaxis_attr.cpp").c_str()); 
+  axis.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"iaxis_attr.F90").c_str()); 
+  axis.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"axisgroup_interface_attr.f90").c_str()); 
+  axisgroup.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icaxisgroup_attr.cpp").c_str()); 
+  axisgroup.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"iaxisgroup_attr.F90").c_str()); 
+  axisgroup.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"domain_interface_attr.f90").c_str()); 
+  domain.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icdomain_attr.cpp").c_str()); 
+  domain.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"idomain_attr.F90").c_str()); 
+  domain.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"domaingroup_interface_attr.f90").c_str()); 
+  domaingroup.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icdomaingroup_attr.cpp").c_str()); 
+  domaingroup.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"idomaingroup_attr.F90").c_str()); 
+  domaingroup.generateFortranInterface(file) ;
+  file.close();
+  
+  
+  file.open((path+"grid_interface_attr.f90").c_str()); 
+  grid.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icgrid_attr.cpp").c_str()); 
+  grid.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"igrid_attr.F90").c_str()); 
+  grid.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"gridgroup_interface_attr.f90").c_str()); 
+  gridgroup.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icgridgroup_attr.cpp").c_str()); 
+  gridgroup.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"igridgroup_attr.F90").c_str()); 
+  gridgroup.generateFortranInterface(file) ;
+  file.close();
+  
+  
+  file.open((path+"field_interface_attr.f90").c_str()); 
+  field.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icfield_attr.cpp").c_str()); 
+  field.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"ifield_attr.F90").c_str()); 
+  field.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"fieldgroup_interface_attr.f90").c_str()); 
+  fieldgroup.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icfieldgroup_attr.cpp").c_str()); 
+  fieldgroup.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"ifieldgroup_attr.F90").c_str()); 
+  fieldgroup.generateFortranInterface(file) ;
+  file.close();
+  
+
+
+  file.open((path+"file_interface_attr.f90").c_str()); 
+  afile.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icfile_attr.cpp").c_str()); 
+  afile.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"ifile_attr.F90").c_str()); 
+  afile.generateFortranInterface(file) ;
+  file.close();
+  
+  file.open((path+"filegroup_interface_attr.f90").c_str()); 
+  filegroup.generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"icfilegroup_attr.cpp").c_str()); 
+  filegroup.generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"ifilegroup_attr.F90").c_str()); 
+  filegroup.generateFortranInterface(file) ;
+  file.close();
+  
+ 
+  file.open((path+"context_interface_attr.f90").c_str()); 
+  context->generateFortran2003Interface(file) ;
+  file.close();
+  
+  file.open((path+"iccontext_attr.cpp").c_str()); 
+  context->generateCInterface(file) ;
+  file.close();
+  
+  file.open((path+"icontext_attr.F90").c_str()); 
+  context->generateFortranInterface(file) ;
+  file.close();
+  
+}
Index: /XIOS/trunk/src/generate_interface.hpp
===================================================================
--- /XIOS/trunk/src/generate_interface.hpp	(revision 313)
+++ /XIOS/trunk/src/generate_interface.hpp	(revision 313)
@@ -0,0 +1,66 @@
+#ifndef  __XIOS_GENERATE_INTERFACE_HPP__
+#define  __XIOS_GENERATE_INTERFACE_HPP__
+
+#include "xmlioserver_spl.hpp"
+
+namespace xmlioserver
+{
+  class CInterface
+  {
+    public:
+    
+    template <class T>
+    static void AttributeCInterface(ostream& oss,const string& className,const string& name) ;
+   
+   template <class T>
+   static void AttributeFortran2003Interface(ostream& oss,const string& className,const string& name) ;
+   
+   template <class T>
+   static void AttributeFortranInterfaceDeclaration(ostream& oss,const string& className,const string& name) ;
+   
+   template <class T>
+   static void AttributeFortranInterfaceGetDeclaration(ostream& oss,const string& className,const string& name) ;
+
+   template <class T>
+   static void AttributeFortranInterfaceBody(ostream& oss,const string& className,const string& name) ;
+  
+   template <class T>
+   static void AttributeFortranInterfaceGetBody(ostream& oss,const string& className,const string& name) ;
+  
+   template <class T>
+   static string getStrFortranType(void) ;
+
+   template <class T>
+   static string getStrFortranKind(void) ;
+    
+   template <class T>
+   static string getStrFortranKindC(void) ;
+   
+   template <class T>
+   static bool matchingTypeCFortran(void) ;
+   
+
+  };
+  
+  template<> string CInterface::getStrFortranType<int>(void) {return string("INTEGER") ;}
+  template<> string CInterface::getStrFortranType<bool>(void) {return string("LOGICAL") ;}
+  template<> string CInterface::getStrFortranType<double>(void) {return string("REAL") ;}
+  template<> string CInterface::getStrFortranType<float>(void) {return string("REAL") ;}
+  
+  template<> string CInterface::getStrFortranKind<int>(void) {return string("") ;}
+  template<> string CInterface::getStrFortranKind<bool>(void) {return string("") ;}
+  template<> string CInterface::getStrFortranKind<double>(void) {return string("(KIND=8)") ;}
+  template<> string CInterface::getStrFortranKind<float>(void) {return string("(KIND=4)") ;}
+  
+  template<> string CInterface::getStrFortranKindC<int>(void) {return string("(KIND=C_INT)") ;}
+  template<> string CInterface::getStrFortranKindC<bool>(void) {return string("(KIND=C_BOOL)") ;}
+  template<> string CInterface::getStrFortranKindC<double>(void) {return string("(KIND=C_DOUBLE)") ;}
+  template<> string CInterface::getStrFortranKindC<float>(void) {return string("(KIND=C_FLOAT)") ;}
+  
+  template<> bool CInterface::matchingTypeCFortran<int>(void) { return true ; } 
+  template<> bool CInterface::matchingTypeCFortran<bool>(void) { return false ;} 
+  template<> bool CInterface::matchingTypeCFortran<double>(void) { return true; }
+  template<> bool CInterface::matchingTypeCFortran<float>(void) { return true; }
+  
+}
+#endif
